#
#   Emily Echevarria
#*********************************************************

from gvportage import *


class Horse(vportage_utils.frame):
	def __init__(self, transform_frame, pos = None):
		vportage_utils.frame.__init__(self, frame = transform_frame, pos = pos)
		
		self.world_fr=self
				
		xaxis = (1, 0, 0)
		yaxis = (0, 1, 0)
		zaxis = (0, 0, 1)
		
		M_PI = 3.14159
		
		pi = M_PI
		
		
		#HORSE
		
		# Initialize the frame system for the horse
		self.barrel = frame(frame = self.world_fr)
		self.point_of_hip = frame(frame = self.barrel)
		self.point_of_croup = frame(frame = self.barrel)
		self.withers = frame(frame = self.point_of_croup)
		self.point_of_tail = frame(frame = self.point_of_hip)
		self.point_of_tail2 = frame(frame = self.point_of_tail)
		self.offpoint_of_hip = frame(frame = self.point_of_hip)
		self.nearpoint_of_hip = frame(frame = self.point_of_hip)
		self.poll = frame(frame = self.withers)
		self.right_earframe = frame(frame = self.poll)
		self.left_earframe = frame(frame = self.poll)
		self.offside_elbow = frame(frame = self.point_of_croup)
		self.offside_knee = frame(frame = self.offside_elbow)
		self.offsidefore_pasternjoint = frame(frame = self.offside_knee)
		self.nearside_elbow = frame(frame = self.point_of_croup)
		self.nearside_knee = frame(frame = self.nearside_elbow)
		self.nearsidefore_pasternjoint = frame(frame = self.nearside_knee)
		self.offside_hock = frame(frame = self.offpoint_of_hip)
		self.offsideback_pasternjoint = frame(frame = self.offside_hock)
		self.nearside_hock = frame(frame = self.nearpoint_of_hip)
		self.nearsideback_pasternjoint = frame(frame = self.nearside_hock)
		self.offsidefore_hoof = frame(frame = self.offsidefore_pasternjoint)
		self.nearsidefore_hoof = frame(frame = self.nearsidefore_pasternjoint)
		self.offsideback_hoof = frame(frame = self.offsideback_pasternjoint)
		self.nearsideback_hoof = frame(frame = self.nearsideback_pasternjoint)
		
		
		#Initialize joints for the horse in their correct frames
		self.witherspoint = sphere(frame = self.withers, pos=(0,0,0), color = color.yellow, radius = .2)
		self.point_of_crouppoint = sphere(frame = self.point_of_croup, pos=(0,0,0), color = color.green, radius = .2)
		self.point_of_tailpoint = sphere(frame = self.point_of_tail, pos=(0,0,0), color = color.red, radius = .2)
		self.point_of_tail2point = sphere(frame = self.point_of_tail2, pos=(0,-.1,0), color = color.red, radius = .2)
		self.pollpoint = sphere(frame = self.poll, pos=(-.5,0,0), color = color.red, radius = .2)
		self.right_earpoint = sphere(frame = self.right_earframe, pos=(0,0,0), color = color.red, radius = .2)
		self.left_earpoint = sphere(frame = self.left_earframe, pos=(0,0,0), color = color.red, radius = .2)
		self.offside_elbowpoint = sphere(frame = self.offside_elbow, pos=(0,0,0), color = color.green, radius = .2)
		self.offside_kneepoint = sphere(frame = self.offside_knee, pos=(0,0,0), color = (color.yellow), radius = .4)
		self.nearside_kneepoint = sphere(frame = self.nearside_knee, pos=(0,0,0), color = (color.yellow), radius = .4)
		self.offside_hockpoint = sphere(frame = self.offside_hock, pos=(0,0,0), color = (color.yellow), radius = .4)
		self.nearside_hockpoint = sphere(frame = self.nearside_hock, pos=(0,0,0), color = (color.yellow), radius = .4)
		self.nearside_elbowpoint = sphere(frame = self.nearside_elbow, pos=(0,0,0), color = color.green, radius = .2)
		self.offsidefore_pasternjointpoint = sphere(frame = self.offsidefore_pasternjoint, pos=(0,0,0), color = (color.yellow), radius = .35)
		self.nearsidefore_pasternjointpoint = sphere(frame = self.nearsidefore_pasternjoint, pos=(0,0,0), color = (color.yellow), radius = .35)
		self.offsideback_pasternjointpoint = sphere(frame = self.offsideback_pasternjoint, pos=(0,0,0), color = (color.yellow), radius = .35)
		self.nearsideback_pasternjointpoint = sphere(frame = self.nearsideback_pasternjoint, pos=(0,0,0), color = (color.yellow), radius = .35)
		self.offsideback_pasternjointpoint = sphere(frame = self.offsideback_pasternjoint, pos=(0,0,0), color = (color.yellow), radius = .35)
		self.nearsideback_pasternjointpoint = sphere(frame = self.nearsideback_pasternjoint, pos=(0,0,0), color = (color.yellow), radius = .35)
		self.offsidefore_hoofpoint = ellipsoid(frame = self.offsidefore_hoof, pos=(0,0,0), size = (.9, .6, .8), color = color.green)
		self.nearsidefore_hoofpoint = ellipsoid(frame = self.nearsidefore_hoof, pos=(0,0,0), size = (.9, .6, .8), color = color.green)
		self.offsideback_hoofpoint = ellipsoid(frame = self.offsideback_hoof, pos=(0,0,0), size = (.9, .6, .8), color = color.green)
		self.nearsideback_hoofpoint = ellipsoid(frame = self.nearsideback_hoof, pos=(0,0,0), size = (.9, .6, .8), color = color.green)
		self.offpoint_of_hippoint = sphere(frame = self.offpoint_of_hip, pos=(0,0,0), color = color.green, radius = .2)
		self.nearpoint_of_hippoint = sphere(frame = self.nearpoint_of_hip, pos=(0,0,0), color = color.green, radius = .2)
		
		
		#Initialize the horse's body parts
		self.ribs = ellipsoid(frame = self.point_of_croup, pos=(2, 0, 0), size = (6, 2.8, 2.8), color = color.yellow)
		self.sternum = ellipsoid(frame = self.point_of_croup, pos=(4, 0, 0), size = (3, 3, 3), color = color.yellow)
		self.hindquarters = ellipsoid(frame = self.point_of_croup, pos=(0, 0, 0), size = (3, 3, 3), color = color.yellow)
		self.cervicalvertebrae = ellipsoid (frame = self.withers, pos=(2, -.2, 0), size = (5, 1.7, 1), color = (color.yellow))
		self.head1 = ellipsoid(frame = self.poll, pos=(0, -.5, 0), size = (1.8, 1.8, 1.7), color = (color.yellow))
		self.head2 = ellipsoid(frame = self.poll, pos=(0, -1.6,0), size = (1.3, 1.3, 1.3), color = (color.yellow))
		
		self.tail1 = ellipsoid(frame = self.point_of_tail, pos=(0, -.5, 0), size = (.4, 1.5, .4), color = color.red)
		self.tail2 = ellipsoid(frame = self.point_of_tail2, pos=(0, -1.5,0), size = (.4, 3, .5), color = color.red)
		
		self.mane1 = ellipsoid(frame = self.withers, pos=(1.75, .4, 0), length = 5.5, width = .1, depth = .1, color = color.red)
		self.mane2 = ellipsoid(frame = self.poll, pos=(.37, -.05,0), length =1, width = .1, depth = 2, color = color.red)
		
		self.offtibia = ellipsoid(frame = self.offpoint_of_hip, pos=(0, -1.75, 0), size = (1.8, 4, 1.8), color = (color.yellow))
		self.neartibia = ellipsoid(frame = self.nearpoint_of_hip, pos=(0, -1.75, 0), size = (1.8, 4, 1.8), color = (color.yellow))
		self.offradius = ellipsoid(frame = self.offside_elbow, pos=(0, -.7, 0), size = (1.2, 3, 1.2), color = (color.yellow))
		self.nearradius = ellipsoid(frame = self.nearside_elbow, pos=(0, -.7, 0), size = (1.2, 3, 1.2), color = (color.yellow))
		self.offcannon = ellipsoid(frame = self.offside_knee, pos=(0, -.75, 0), size = (.85, 2, .85), color = (color.yellow))
		self.nearcannon = ellipsoid(frame = self.nearside_knee, pos=(0, -.75, 0), size = (.85, 2, .85), color = (color.yellow))
		self.offpastern = ellipsoid(frame = self.offsidefore_pasternjoint, pos=(0, -.5, 0), size = (.7, 1, .7), color = (color.yellow))
		self.nearpastern = ellipsoid(frame = self.nearsidefore_pasternjoint, pos=(0, -.5, 0), size = (.7, 1, .7), color = (color.yellow))
		
		self.offbackpastern = ellipsoid(frame = self.offsideback_pasternjoint, pos=(0, -.5, 0), size = (.7, 1, .7), color = (color.yellow))
		self.nearbackpastern = ellipsoid(frame = self.nearsideback_pasternjoint, pos=(0, -.5, 0), size = (.7, 1, .7), color = (color.yellow))
		
		self.offbackcannon = ellipsoid(frame = self.offside_hock, pos=(0, -.75, 0), size = (.9, 2.5, .9), color = (color.yellow))
		self.nearbackcannon = ellipsoid(frame = self.nearside_hock, pos=(0, -.75, 0), size = (.9, 2.5, .9), color = (color.yellow))
		
		self.right_ear = ellipsoid(frame = self.right_earframe, pos=(.2, .1, 0), size = (1, .4, .6), color = (color.yellow))
		self.left_ear = ellipsoid(frame = self.left_earframe, pos=(.2, .1, 0), size = (1, .4, .6), color = (color.yellow))
		
		
		#offside_kneepoint.velocity = vector(0,0,0)
		
				
		#Move the horse's frame to their correct starting locations
		self.barrel.pos=(0, 2.2, 0)
		self.withers.pos=(3.3, 0,0)
		self.point_of_hip.pos = (0, 0, 0)
		self.point_of_croup.pos = (-2, -1, 0)
		self.offpoint_of_hip.pos = (-2,0,.75)
		self.nearpoint_of_hip.pos = (-2,0,-.75)
		self.point_of_tail.pos = (-3, 0, 0)
		self.point_of_tail2.pos = (0, -1, 0)
		self.poll.pos = (4, 0, 0)
		self.left_earframe.pos = (.5, -.2, -.4)
		self.right_earframe.pos = (.5, -.2, .4)
		self.offside_elbow.pos = (4.2, -1, .7)
		self.offside_knee.pos = (0, -2, 0)
		self.offsidefore_pasternjoint.pos = (0,-1.5, 0)
		self.nearside_elbow.pos = (4.2, -1, -.7)
		self.nearside_knee.pos = (0, -2, 0)
		self.nearsidefore_pasternjoint.pos = (0,-1.5, 0)
		self.offsidefore_hoof.pos = (0, -.8, 0)
		self.nearsidefore_hoof.pos = (0, -.8, 0)
		self.offsideback_hoof.pos = (0, -.8, 0)
		self.nearsideback_hoof.pos = (0, -.8, 0)
		self.offside_hock.pos = (0, -3.5, 0)
		self.offsideback_pasternjoint.pos = (0,-2,0)
		self.nearside_hock.pos = (0, -3.5, 0)
		self.nearsideback_pasternjoint.pos = (0,-2,0)
	
		#reset horse's colors
		self.ribs.color =color.yellow
		self.sternum.color = color.yellow
		self.hindquarters.color = color.yellow
		self.cervicalvertebrae.color = (.2,.2,.9)
		self.head1.color =(.2,.2,.9)
		self.head2.color = (.2,.2, .9)
		self.tail1.color =color.red
		self.tail2.color = color.red
		self.mane1.color = color.red
		self.mane2.color = color.red
		self.point_of_tailpoint.color = color.red
		self.point_of_tail2point.color = color.red
		self.offtibia.color =(.2,.2,.9)
		self.neartibia.color = (.2,.2,.9)
		self.offradius.color =(.2,.2,.9)
		self.nearradius.color = (.2,.2,.9)
		self.offcannon.color =(.2,.2,.9)
		self.nearcannon.color = (.2,.2,.9)
		self.offpastern.color =(.2,.2,.9)
		self.nearpastern.color = (.2,.2,.9)
		self.offbackpastern.color =(.2,.2,.9)
		self.nearbackpastern.color = (.2,.2,.9)
		self.offbackcannon.color =(.2,.2,.9)                                           
		self.nearbackcannon.color = (.2,.2,.9)
		self.right_ear.color =(.2,.2,.9)
		self.left_ear.color = (.2,.2,.9)
		self.offside_kneepoint.color = (.2, .2, .9)
		self.nearside_kneepoint.color = (.2,.2,.9)
		self.offside_hockpoint.color = (.2, .2, .9)
		self.nearside_hockpoint.color = (.2,.2,.9)
		self.offsidefore_pasternjointpoint.color = (.2,.2,.9)
		self.nearsidefore_pasternjointpoint.color = (.2,.2,.9)
		self.offsideback_pasternjointpoint.color = (.2, .2, .9)
		self.nearsideback_pasternjointpoint.color = (.2, .2, .9)
		self.offsidefore_hoofpoint.color = color.green
		self.nearsidefore_hoofpoint.color = color.green
		self.offsideback_hoofpoint.color = color.green
		self.nearsideback_hoofpoint.color = color.green
		
		#rotate parts of horse to begin in initial stance
		self.nearsidefore_pasternjoint.rotate(angle=pi/8, axis=(0,0,1))
		self.offsidefore_pasternjoint.rotate(angle=pi/8, axis=(0,0,1))
		self.nearsideback_pasternjoint.rotate(angle=pi/16, axis=(0,0,1))
		self.offsideback_pasternjoint.rotate(angle=pi/16, axis=(0,0,1))
		self.nearsidefore_hoof.rotate(angle=-pi/8, axis=(0,0,1))
		self.offsidefore_hoof.rotate(angle=-pi/8, axis=(0,0,1))
		self.nearsideback_hoof.rotate(angle=-pi/8, axis=(0,0,1))
		self.offsideback_hoof.rotate(angle=-pi/8, axis=(0,0,1))
		self.withers.rotate(angle=pi/4, axis=(0,0,1))
		self.offpoint_of_hip.rotate(angle =-pi/16, axis=(0,0,1))
		self.nearpoint_of_hip.rotate(angle=-pi/16, axis=(0,0,1))
		self.offside_hock.rotate(angle=pi/8, axis = (0,0,1))
		self.nearside_hock.rotate(angle=pi/8, axis = (0,0,1))
		self.point_of_tail.rotate(angle=-pi/6, axis = (0,0,1))
		self.point_of_tail2.rotate(angle=pi/6, axis = (0,0,1))   	  
		
class Rider(vportage_utils.frame):
	def __init__(self, transform_frame, pos = None):
		vportage_utils.frame.__init__(self, frame = transform_frame, pos = pos)
			
		self.human_fr = frame(frame=self)
		self.waist=frame(frame=self.human_fr)
		self.neck=frame(frame=self.waist)
		self.lshoulder=frame(frame=self.waist)
		self.rshoulder=frame(frame=self.waist)
		self.lelbow=frame(frame=self.lshoulder) 
		self.relbow=frame(frame=self.rshoulder)
		self.lwrist=frame(frame=self.lelbow)
		self.rwrist=frame(frame=self.relbow)
		self.lhip=frame(frame=self.human_fr)
		self.rhip=frame(frame=self.human_fr)
		self.lknee=frame(frame=self.lhip)
		self.rknee=frame(frame=self.rhip) 
		self.lankle=frame(frame=self.lknee) 
		self.rankle=frame(frame=self.rknee)
		#Initilize joints in their correct frames
		self.neckpoint = sphere(frame=self.neck, pos=(0,0,0), color=color.cyan, radius = .2)
		self.lshoulderpoint = sphere(frame=self.lshoulder, pos=(0,0,0), color =color.cyan, radius=.25)
		self.rshoulderpoint = sphere(frame=self.rshoulder, pos=(0,0,0), color= color.cyan, radius=.25)
		self.lelbowpoint = sphere(frame=self.lelbow, pos=(0,0,-.1), color=color.cyan, radius=.2)
		self.relbowpoint = sphere(frame=self.relbow, pos=(0,0,-.1), color=color.cyan, radius=.2)
		self.lwristpoint = sphere(frame=self.lwrist, pos=(0,0,-.1), color= color.cyan, radius=.1)
		self.rwristpoint = sphere(frame=self.rwrist, pos=(0,0,-.1), color=color.cyan, radius=.1)
		self.lhippoint = sphere(frame=self.lhip, pos=(0,0,0), color=color.cyan, radius=.3)
		self.rhippoint = sphere(frame=self.rhip, pos=(0,0,0), color= color.cyan, radius=.3)
		self.lkneepoint = sphere(frame=self.lknee, pos=(0,0,0), color=color.cyan, radius=.2)
		self.rkneepoint = sphere(frame=self.rknee, pos=(0,0,0), color=color.cyan, radius=.2)
		self.lanklepoint = sphere(frame=self.lankle, pos=(0,0,0), color= color.cyan, radius=.2)
		self.ranklepoint = sphere(frame=self.rankle, pos=(0,0,0), color=color.cyan, radius=.2)
		self.waistpoint = sphere(frame=self.waist, pos=(0,0,0), color=color.cyan, radius = .4)
		# Initialize body parts in their correct frames
		self.utorso = ellipsoid(frame=self.waist,pos=(0,.5,0), size = (1, 2, 1),
						color=(color.cyan))
		self.ltorso = ellipsoid(frame=self.human_fr, pos=(0,-.5,0), size =(1, 1.5, 1), color = (color.cyan)) 
		self.head = sphere(frame=self.neck,pos=(0,.5,0), radius=.5,color=(color.cyan))
		
		self.lhumerous = ellipsoid(frame=self.lshoulder, pos=(.5,0,-.1), size=(1.5, .4, .4),
						color=(color.cyan))
		
		self.rhumerous = ellipsoid(frame=self.rshoulder, pos=(-.5,0,-.1), size=(1.5, .4, .4),color=(color.cyan))
		
		self.lradius = ellipsoid(frame=self.lelbow, pos=(.5,0,-.1), size=(1.5, .4, .3),
						color=(color.cyan))
		
		self.rradius = ellipsoid(frame=self.relbow, pos=(-.5,0,-.1), size=(1.5, .3, .4), color=(color.cyan))
		
		self.lhand = ellipsoid(frame=self.lwrist, pos=(.25,0,-.1), size=(.5, .3, .3),color=(color.cyan))
		
		self.rhand = ellipsoid(frame=self.rwrist, pos=(-.25,0,-.1), size = (.5, .3, .3),color=(color.cyan))
		
		self.lfemur = ellipsoid(frame=self.lhip, pos=(0,-.75,0), size=(.5, 2, .5), color=(color.cyan))
		
		self.rfemur = ellipsoid(frame=self.rhip, pos=(0,-.75,0), size=(.5, 2, .5), color=(color.cyan))
		
		self.ltibia = ellipsoid(frame=self.lknee, pos=(0,-.75,0), size=(.5, 2, .5), color=(color.cyan))
		
		self.rtibia = ellipsoid(frame=self.rknee, pos=(0,-.75,0), size=(.5, 2, .5), color=(color.cyan))
		
		self.lfoot = box(frame=self.lankle, pos=(0,0,.25), length=.3, height=.2, 
						width=.45,color=(color.cyan))
		
		self.rfoot = box(frame=self.rankle, pos=(0,0,.25), length=.3, height=.2, 
						width=.45,color=(color.cyan))
		# Move the frames to their correct starting locations (i.e. glTranslate)
		# All .pos are relative to the frame that they are in
		
		self.human_fr.pos.x += 1.6
		self.human_fr.pos.y += 2.5
		self.neck.pos=(0,1.5,0)
		self.lshoulder.pos=(.55,1.3,0)
		self.rshoulder.pos= (-.55,1.3,0)
		self.lelbow.pos=(1.05,0,0)
		self.relbow.pos=(-1.05,0,0)
		self.lwrist.pos=(1.0,0,0)
		self.rwrist.pos=(-1.0,0,0)
		self.lhip.pos=(.35,-1.,0)
		self.rhip.pos=(-.35,-1.,0)
		self.lknee.pos=(0,-1.6,0)
		self.rknee.pos=(0,-1.6,0)
		self.lankle.pos= (0,-1.6,0)
		self.rankle.pos=(0,-1.6,0)
		self.waist.pos=(0, 0,0)

		self.utorso.color=(.2,.2,.9)
		self.ltorso.color=(.2, .2, .9)
		self.head.color= (.2,.2,.9)
		self.lhumerous.color=(.2,.2,.9)
		self.rhumerous.color=(.2,.2,.9)
		self.lradius.color= (.2,.2,.9)
		self.rradius.color=(.2,.2,.9)
		self.lhand.color=(.2,.2,.9)
		self.rhand.color=(.2,.2,.9)
		self.lfemur.color= (.2,.2,.9)
		self.rfemur.color=(.2,.2,.9)
		self.ltibia.color=(.2,.2,.9)
		self.rtibia.color=(.2,.2,.9) 
		self.lfoot.color=(.2,.2,.9)
		self.rfoot.color=(.2,.2,.9)

	
		#rotate parts of human
		self.lshoulder.rotate(angle=-pi/2, axis=(0,1,0))
		self.lshoulder.rotate(angle=pi/4, axis=(0,0,1))
		self.lshoulder.rotate(angle=pi/4, axis=(1,0,0))
		self.rshoulder.rotate(angle=pi/2, axis=(0,1,0))
		self.rshoulder.rotate(angle=-pi/4, axis=(0,0,1))
		self.rshoulder.rotate(angle= pi/4, axis=(1,0,0))
		self.relbow.rotate(angle = -pi/4, axis=(0, 0, 1))
		self.lelbow.rotate(angle =  pi/4, axis=(0,0,1))
		self.relbow.rotate(angle = -pi/4, axis=(0, 1, 0))
		self.lelbow.rotate(angle =  pi/4, axis=(0,1,0))
		self.waist.rotate(angle = pi/8, axis =(1, 0, 0))
		
		self.lhip.rotate(angle = -pi/2, axis = (1, 0, 0))
		self.rhip.rotate(angle=-pi/2, axis = (1, 0, 0))
		self.lhip.rotate(angle = pi/8, axis= (0, 1, 0))
		self.rhip.rotate(angle=-pi/8, axis = (0, 1, 0))
		self.lknee.rotate(angle = 3*pi/4, axis = (1, 0, 0))
		self.rknee.rotate(angle=3*pi/4, axis = (1, 0, 0))
		self.lknee.rotate(angle = -pi/4, axis = (0, 1, 0))
		self.rknee.rotate(angle=pi/4, axis = (0, 1, 0))
		self.human_fr.rotate(angle=pi/2, axis = (0, 1, 0))
		
		
		
		
		
		
			
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

